<?php

// PHP Dateibrowser
// Version 1.4.2
// (C) Copyright 2009 - 2010 ViaThinkSoft
// Projektleiter: Daniel Marschall

// INFORMATION
// Dies ist die Kernkomponente des Dateibrowsers und verwaltet das Auslesen
// der Verzeichnisse, das Parsen der URLs sowie die Behandlung aller Umleitungen.
// Apache muss jedoch weiterhin Zugriff auf die Verzeichnisse haben, da der Dateidownload
// nicht ber den Browser erfolgt (Feature fr Zukunft?). Dateien, die mit dem Dateibrowser
// versteckt wurden (z.B. hidden_*) sind im Apache Directory-Listing weiterhin verfgbar!
// Daher sollte das Directory Listing abgeschaltet sein ("Options -Indexes" in der .htaccess).

/*

BUG:
Ist URL-REWRITING aktiv, kann kein Verzeichnis /x/ aufgerufen werden, das ebenfalls die Rewrite-Engine benutzt. Wie knnen die Regeln dorthin bertragen werden, sodass auch dieses Verzeichnis korrekt angezeigt werden kann? (Problematik gilt auch fr das "home"-rewriting bei VTS)
Meldung "Freigeschaltet" funktioniert bei Use-Redirect nicht.

MISSING FEATURE:
Man soll einstellen knnen, ob man bei einem Verzeichnis die Index automatisch ffnen will oder nicht (bei Use-Rewriting-Modus)

UNWICHTIG:
USE_REWRITING ggf. durch automatische erkennung der .htaccess substituieren?
Rewrite-Argument $1 lieber per Post bergeben bekommen anstelle ber $_GET?

*/

// -------------------------------------------------------------------------------------------------------------------------
// AB DIESER STELLE BITTE NICHTS EDITIEREN!
// -------------------------------------------------------------------------------------------------------------------------

// Equal code in Accessor
define('CFG_FILE', 'dateibrowser_config.inc.php');

// Equal code in Accessor
define('IDX_FILE', 'index.php');

define('ACCESSOR_FILE', 'dateibrowser_accessor.php');

define('DATEIBROWSER_ROOT', dir_add_trailing_backslash(dirname($_SERVER['SCRIPT_FILENAME'])));

// *** Laden der Konfiguration (identisch mit Accessor) ***

if (!file_exists(DATEIBROWSER_ROOT.CFG_FILE)) die('Konfigurationsdatei &quot;'.CFG_FILE.'&quot; fehlt!');

// Arrays vordefinieren
$hidden_file_masks = array();
$additional_head_elements = array();

// Funktions-, Helfer- und Konfigurationsdateien ausblenden
$hidden_file_masks[] = 'dateibrowser_*';

// Versteckte Linux-Dateien/Ordner ausblenden
$hidden_file_masks[] = '.*';

require(DATEIBROWSER_ROOT.CFG_FILE);

if ((!defined('PERSON_NAME')) ||
    (!defined('PERSON_EMAIL')) ||
    (!defined('SEITEN_TITEL')) ||
    (!defined('ROOT_DIR_NAME')) ||
    (!defined('DATEIBROWSER_BASE_URL')) ||
    (!defined('CFG_SHOW_SIZE')) ||
    (!defined('CFG_SHOW_MOD_DATE')) ||
    (!defined('USE_REWRITING')) ||
    (!defined('FILENAME_ENCODING'))) {
	die('Fehler: Konfiguration unvollst&auml;ndig!');
}

// Equal code in Accessor
define('PAGE_ENCODING', 'iso-8859-1');
define('B_START_YEAR', '2009');
define('B_VERSION', '1.4.2');

// PHP-AntiSpam-Funktion "secure_email", Version 3.02 of 2009-09-23
// von Daniel Marschall [www.daniel-marschall.de]

function secure_email($email, $linktext, $crypt_linktext)
{
	// No new lines to avoid a JavaScript error!
	$linktext = str_replace("\r", ' ', $linktext);
	$linktext = str_replace("\n", ' ', $linktext);

	if (!function_exists('alas_js_crypt'))
	{
		function alas_js_crypt($text)
		{
			$tmp = '';
			for ($i=0; $i<strlen($text); $i++)
			{
				$tmp .= 'document.write("&#'.ord(substr($text, $i, 1)).';");';
			}
			return $tmp;
		}
	}

	if (!function_exists('alas_js_write'))
	{
		function alas_js_write($text)
		{
			$text = str_replace('\\', '\\\\', $text);
			$text = str_replace('"', '\"', $text);
			$text = str_replace('/', '\/', $text); // W3C Validation </a> -> <\/a>
			return 'document.write("'.$text.'");';
		}
	}

	$aus = '';
	if ($email != '')
	{
		$aus .= '<script language="JavaScript" type="text/javascript"><!--'."\n";
		$aus .= alas_js_write('<a href="');
		$aus .= alas_js_crypt('mailto:'.$email);
		$aus .= alas_js_write('">');
		$aus .= $crypt_linktext ? alas_js_crypt($linktext) : alas_js_write($linktext);
		$aus .= alas_js_write('</a>').'// --></script>';
	}

	return $aus;
}

// Equal code in Accessor
function absolute_path_to_relative_path($path, $new_base) {
	$path = realpath($path);
	$new_base = realpath($new_base);
	return '.'.str_replace($new_base, '', $path);
}

// Equal code in Accessor
function beginning_in_array($search_string, $array) {
	if (isset($array)) {
		foreach ($array as $val) {
			if (substr($search_string, 0, strlen($val)) == $val) return true;
		}
	}

	return false;
}

function is_in_allow_list($directory) {
	if (isset($_SESSION['dateibrowser_allowdirs'])) {
		return beginning_in_array(realpath($directory).'/', $_SESSION['dateibrowser_allowdirs']);
	} else {
		return false;
	}
}

// Equal code in Accessor
function dir_add_trailing_backslash($directory) {
	if (substr($directory, strlen($directory)-1, 1) != '/') $directory .= '/';
	return $directory;
}

// http://snippets.dzone.com/posts/show/2776
function file_extension($filename)
{
	$path_info = pathinfo($filename);
	return $path_info['extension'];
}

function is_an_urlfile($file) {
	return (strtolower(file_extension($file)) == 'url');
}

function get_url_from_urlfile($file) {
	// http://www.viathinksoft.de/?page=codelib&showid=67

	if (!file_exists($file)) return false;
	if (!is_readable($file)) return false;

	$raw = file_get_contents($file);
	$raw = str_replace("\r", "\n", $raw);
	$ary = explode("\n", $raw);

	$in_section = false;
	foreach ($ary as $val) {
		if ($in_section) {
			$bry = explode('=', $val);
			if (trim(strtolower($bry[0])) == strtolower('URL')) {
				array_shift($bry);
				return implode('=', $bry);
			}
		}

		if (substr(trim($val), 0, 1) == '[') {
			$in_section = false;
		}
		if (str_replace(' ', '', strtolower($val)) == strtolower('[InternetShortcut]')) {
			$in_section = true;
		}
	}
	unset($in_section);
	unset($val);

	return false;
}

function is_hidden($file_or_dir) {
	global $hidden_file_masks;

	// Die systemeigenen und benutzerdefinierten Masken ausblenden
	foreach ($hidden_file_masks as $val) {
		if (fnmatch($val, basename($file_or_dir))) return true;
	}

	// Das eigene Script ausblenden
	if (realpath($file_or_dir) == $_SERVER['SCRIPT_FILENAME']) return true;

	return false;
}

function is_directory_empty($directory) {
	$directory = dir_add_trailing_backslash($directory);

	$c = 0;
	$handle = openDir($directory);
	while ($file = readDir($handle)) {
		if (($file != '.') && ($file != '..') && (!is_hidden($directory.$file))) {
			$c++;
		}
	}
	closeDir($handle);
	return $c == 0;
}

// Equal code in Accessor
function list_up_directories($directory) {
	$idir = realpath($directory);
	$idir = dir_add_trailing_backslash($idir);

	$ary[] = $idir;

	$alt = NULL;
	while (($alt != $idir) && ($idir != '/')) {
		$alt = $idir;
		$idir = @realpath($idir.'../');
		$idir = dir_add_trailing_backslash($idir);
		$ary[] = $idir;
	}
	unset($alt);

	return $ary;
}

function is_secured_directory($directory) {
	// Es werden auch alle bergeordnete Verzeichnisse durchsucht
	$baum = list_up_directories($directory);

	$res = false;

	foreach ($baum as $val) {
		if ((has_htaccess_file($val)) && (htaccess_file_is_password_secured($val.'.htaccess'))) {
			$res = true;
			break;
		}
	}

	return $res;
}

function has_htaccess_file($directory) {
	return @file_exists(dir_add_trailing_backslash($directory).'.htaccess');
}

function htaccess_file_is_password_secured($file) {
	$c = file_get_contents($file);

	$pos = stripos($c, 'Require ');

	return ($pos !== false);
}

function has_accessor($directory) {
	return file_exists(dir_add_trailing_backslash($directory).ACCESSOR_FILE);
}

function my_filesize($file) {
	$size = filesize($file);

	// Quelle: http://snipplr.com/view/4633/convert-size-in-kb-mb-gb-/
	// An deutsche Kommanotation angepasst
	$filesizename = array(' Bytes', ' KB', ' MB', ' GB', ' TB', ' PB', ' EB', ' ZB', ' YB');
	return $size ? number_format(round($size/pow(1024, ($i = floor(log($size, 1024)))), 2), 2, ',', '.') . $filesizename[$i] : '0 Bytes';
}

function my_filemtime($file) {
	return date ('d.m.Y H:i', filemtime($file));
}

function remove_pointslash($dir) {
	if (substr($dir, 0, 2) == './') $dir = substr($dir, 2, strlen($dir)-2);
	return $dir;
}

function rawurlencode_without_slashes($directorytree) {
	$r = '';

	$ary = explode('/', $directorytree);
	foreach ($ary as $val) {
		$r .= rawurlencode($val).'/';
	}
	unset($val);
	unset($ary);

	$r = substr($r, 0, strlen($r)-1);

	return $r;
}

function fn_decode($filename) {
	// return utf8_decode($filename);
	return mb_convert_encoding($filename, strtoupper(PAGE_ENCODING), FILENAME_ENCODING);
}

function cut_off_beginning($full, $part) {
	if (substr($full, 0, strlen($part)) == $part) {
		return substr($full, strlen($part), strlen($full)-strlen($part)); // cutted
	} else {
		return $full; // false;
	}
}

session_start();

if (isset($_GET['redirect_data'])) {
	// Ein Verzeichnis wurde direkt aufgerufen und per mod_rewrite bergeben!
	// $dir = './'.cut_off_beginning(dir_add_trailing_backslash($_SERVER['DOCUMENT_ROOT']).$_GET['redirect_data'], DATEIBROWSER_ROOT);

	$dir = './'.$_GET['redirect_data'];
} else {
	$dir = (isset($_GET['dir'])) ? $_GET['dir'] : './';
}

// TODO: GEHT NICHT
/* if (USE_REDIRECT) {
	// Ersatz des Accessors
	// ToDo: Funktioniert nicht bei direkt angewhlten Unterverzeichnissen!
	if (is_secured_directory($dir)) {
		$_SESSION['dateibrowser_allowdirs'][] = dir_add_trailing_backslash($dir);
	}
} */

$dir = str_replace('../', '', $dir); // Schutz vor Hackern

$dir = dir_add_trailing_backslash($dir);

if ((is_secured_directory($dir)) && (!is_in_allow_list($dir))) {
	// Zum geschtzen Verzeichnis hin umleiten
	if (USE_REWRITING) {
		// Wir brauchen beim Rewriting nur Umleiten, wenn jemand wirklich index.php?dir=... eingegeben hat
		// Ansonsten befinden wir uns ja offiziell bereits im Verzeichnis, da die Umleitung still erfolgte
		if (!isset($_GET["redirect_data"])) {
			header('location: '.$dir);
			die();
		}
	} else {
		if (has_accessor($dir)) {
			header('location: '.$dir.ACCESSOR_FILE);
			die();
		} else {
			// Vielleicht ist es ein Unterverzeichnis und ein hher liegendes Verzeichnis besitzt einen Accessor

			$baum = list_up_directories($dir);
			foreach ($baum as $val) {
				if (has_accessor($val)) {
					header('location: '.absolute_path_to_relative_path($val, DATEIBROWSER_ROOT).'/'.ACCESSOR_FILE.'?goto='.$dir);
					die();
				}
			}
			unset($baum);

			// Letzte Mglichkeit: Apache-Browser
			header('location: '.$dir);
			die();
		}
	}
}

echo '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<html>

<head>
	<title>'.htmlentities(SEITEN_TITEL).'</title>
	<style type="text/css">
		body, a {
			font-family: Arial;
			font-size: 18px;
			text-decoration: None;
		}
		a:hover {
			color: #EE0000;
		}
	</style>
	<meta http-equiv="Content-type" content="text/html;charset='.PAGE_ENCODING.'">
';
	if (USE_REWRITING) echo '<base href="'.DATEIBROWSER_BASE_URL.'">';
foreach ($additional_head_elements as $val) {
	echo '	'.$val."\n";
}
unset($val);

echo '</head>

<body bgcolor="#FFFFFF" text="#000000" link="#0000FF" vlink="#800080" alink="#FF0000">

<h1>'.htmlentities(SEITEN_TITEL).'</h1>'."\r\n\r\n";

function rec_show_folder($directory) {

	if (!is_dir($directory)) {
		echo '<p><font color="red"><b>Fehler!</b></font><br>';
		echo '<p><font color="red">Dieses Verzeichnis existiert nicht mehr oder wurde umbenannt. Bitte suchen Sie das Verzeichnis im Index erneut.</font></p>';
	} else {
		$files = array();
		$directories = array();

		$directory = dir_add_trailing_backslash($directory);

		$handle = openDir($directory);
		while ($file = readDir($handle)) {
			if (($file != '.') && ($file != '..')) {
				if (is_dir($directory.$file)) {
					array_push($directories, $file);
				} else {
					array_push($files, $file);
				}
			}
		}
		closeDir($handle);

		sort($directories);
		sort($files);

		$somethingfound = false;

		echo '<ul>'."\r\n";
		foreach ($directories as $file) {
			if (!is_hidden($directory.$file)) {
				$somethingfound = true;
				echo '	<li>';
				if (is_directory_empty($directory.$file)) {
					echo '<b>[+] '.fn_decode($file).'</b>';
					if (is_secured_directory($directory.$file)) {
						echo ' [Passwortgesch&uuml;tzt]';
					}
				} else {
					if (is_secured_directory($directory.$file)) {
						if (is_in_allow_list($directory.$file)) {
							echo '<b>[+] <a href="';
							if (USE_REWRITING) {
								echo $directory.$file.'/';
							} else {
								echo $_SERVER['PHP_SELF'].'?dir='.urlencode($directory.$file).'/';
							}
							echo '">'.fn_decode($file).'</a></b> [Freigeschaltet]';
						} else {
							if (USE_REWRITING) {
								echo '<b>[+] <a href="'.rawurlencode_without_slashes($directory.$file.'/').'">'.fn_decode($file).'</a></b> [Passwortgesch&uuml;tzt]';
							} else {
								if (has_accessor($directory.$file)) {
									echo '<b>[+] <a href="'.rawurlencode_without_slashes(remove_pointslash($directory).$file.'/'.ACCESSOR_FILE).'">'.fn_decode($file).'</a></b> [Passwortgesch&uuml;tzt]';
								} else {
									echo '<b>[+] <a href="'.rawurlencode_without_slashes(remove_pointslash($directory).$file.'/').'" target="_blank">'.fn_decode($file).'</a></b> [Passwortgesch&uuml;tzt]';
								}
							}
						}
					} else {
						echo '<b>[+] <a href="';

						if (USE_REWRITING) {
							echo $directory.$file.'/';
						} else {
							echo $_SERVER['PHP_SELF'].'?dir='.urlencode($directory.$file).'/';
						}

						echo '">'.fn_decode($file).'</a></b>';
					}
				}
				echo '</li>'."\r\n";
			}
		}
		foreach ($files as $file) {
			if (!is_hidden($directory.$file)) {
				$somethingfound = true;
				echo '	<li>';
				if (is_an_urlfile($directory.$file)) {
					echo '<a href="'.get_url_from_urlfile($directory.$file).'" target="_blank">'.fn_decode($file).'</a> [Link]';
				} else {
					if (CFG_SHOW_MOD_DATE) {
						echo my_filemtime($directory.$file).': ';
					}
					echo '<a href="'.rawurlencode_without_slashes(remove_pointslash($directory).$file).'" target="_blank">'.fn_decode($file).'</a>';
					if (CFG_SHOW_SIZE) {
						echo ' ('.my_filesize($directory.$file).')';
					}
				}
				echo '</li>'."\r\n";
			}
		}
		echo '</ul>'."\r\n\r\n";

		if (!$somethingfound) {
			echo '<p>In diesem Verzeichnis befinden sich keine Dateien.</p>';
		}
	}
}

$dx = '';

$last_complete = '';

$tmp = '';
$ary = explode('/', $dir);
array_pop($ary);
foreach ($ary as $val) {
	$last_complete = $tmp;
	$tmp .= $val.'/';
	if ($val == '.') $val = ROOT_DIR_NAME;
	$dx .= '<a href="';

	if (USE_REWRITING) {
		$dx .= $tmp;
	} else {
		$dx .= $_SERVER['PHP_SELF'].'?dir='.urlencode($tmp);
	}

	$dx .= '">'.fn_decode($val).'</a> / ';
}
unset($tmp);

echo "<p><b>Aktuelles Verzeichnis: $dx</b></p>\r\n\r\n";
unset($dx);

if ($last_complete != '') {
	echo '<p><b>[^] <a href="';

	if (USE_REWRITING) {
		echo $last_complete;
	} else {
		echo $_SERVER['PHP_SELF'].'?dir='.urlencode($last_complete);
	}

	echo '">Eine Verzeichnisebene h&ouml;her</a></b></p>';
}

rec_show_folder($dir);

echo 'PHP-Dateibrowser '.B_VERSION.' &copy; Copyright '.B_START_YEAR;
if (date('Y') != B_START_YEAR) echo ' - '.date('Y');
echo ' <a href="http://www.viathinksoft.de/" target="_blank">ViaThinkSoft</a>.<br>';

echo 'Betreuer dieser Webseite und Eigent&uuml;mer der Inhalte: '.secure_email(PERSON_EMAIL, PERSON_NAME, false).".\r\n\r\n";

echo '</body>

</html>';

?>
