<?php

// PHP Dateibrowser
// Version 1.4.2
// (C) Copyright 2009 - 2010 ViaThinkSoft
// Projektleiter: Daniel Marschall

// INFORMATION
// Der Accessor ist eine optionale Komponente und erlaubt eine Dateibrowserspezifische
// Darstellung von geschtzten Verzeichnissen. Das Accessorscript ist wichtig, damit die
// Benutzer nicht bei einem passwortgeschtzten Verzeichnis zur Apache-Oberflche
// gelangen und damit die Dateibrowseroberflche verlassen.
// Gleiche Logindaten fr mehrere Verzeichnisse knnen von Apache, jedoch nicht von
// dem Dateibrowser registriert werden.

// INSTALLATION
// Damit der Accesor funktioniert, muss er in JEDES per .htaccess passwortgeschtzte
// Verzeichnis kopiert werden.
// Die Unterverzeichnisse des geschtzten Verzeichnisses brauchen hingegen KEINEN Accessor.

// -------------------------------------------------------------------------------------------------------------------------
// AB DIESER STELLE BITTE NICHTS EDITIEREN!
// -------------------------------------------------------------------------------------------------------------------------

// Equal code in Main-Index
define('CFG_FILE', 'dateibrowser_config.inc.php');

// Equal code in Main-Index
function beginning_in_array($search_string, $array) {
	if (isset($array)) {
		foreach ($array as $val) {
			if (substr($search_string, 0, strlen($val)) == $val) return true;		
		}
	}

	return false;
}

// Equal code in Main-Index
function absolute_path_to_relative_path($path, $new_base) {
	$path = realpath($path);
	$new_base = realpath($new_base);
	return '.'.str_replace($new_base, '', $path);
}

// Equal code in Main-Index
function dir_add_trailing_backslash($directory) {
	if (substr($directory, strlen($directory)-1, 1) != '/') $directory .= '/';
	return $directory;
}

// Equal code in Main-Index
function list_up_directories($directory) {
	$idir = realpath($directory);
	$idir = dir_add_trailing_backslash($idir);

	$ary[] = $idir;

	$alt = NULL;
	while (($alt != $idir) && ($idir != '/')) {
		$alt = $idir;
		$idir = @realpath($idir.'../');
		$idir = dir_add_trailing_backslash($idir);
		$ary[] = $idir;
	}
	unset($alt);

	return $ary;
}

// Equal code in Main-Index
define('IDX_FILE', 'index.php');

function find_dateibrowser_root() {
	$baum = list_up_directories('./');

	foreach ($baum as $val) {
		if ((@file_exists($val.CFG_FILE)) && (@file_exists($val.IDX_FILE))) return $val;
	}

	return false;
}

// *** KONSTANTEN ***

define('DATEIBROWSER_ROOT', find_dateibrowser_root());

// *** Laden der Konfiguration (identisch mit Index) ***

if (!file_exists(DATEIBROWSER_ROOT.CFG_FILE)) die('Konfigurationsdatei &quot;'.CFG_FILE.'&quot; fehlt!');

// Arrays vordefinieren
$hidden_file_masks = array();
$additional_head_elements = array();

// Funktions-, Helfer- und Konfigurationsdateien ausblenden
$hidden_file_masks[] = 'dateibrowser_*';

// Versteckte Linux-Dateien/Ordner ausblenden
$hidden_file_masks[] = '.*';

require(DATEIBROWSER_ROOT.CFG_FILE);

if ((!defined('PERSON_NAME')) ||
    (!defined('PERSON_EMAIL')) ||
    (!defined('SEITEN_TITEL')) ||
    (!defined('ROOT_DIR_NAME')) ||
    (!defined('DATEIBROWSER_BASE_URL')) ||
    (!defined('CFG_SHOW_SIZE')) ||
    (!defined('CFG_SHOW_MOD_DATE')) ||
    (!defined('USE_REWRITING')) ||
    (!defined('FILENAME_ENCODING'))) {
	die('Fehler: Konfiguration unvollst&auml;ndig!');
}

// Equal code in Main-Index
define('PAGE_ENCODING', 'iso-8859-1');
define('B_START_YEAR', '2009');
define('B_VERSION', '1.4');

// *** CODE ***

session_start(); 

$toadd = dirname($_SERVER['SCRIPT_FILENAME']).'/';

if (!beginning_in_array($toadd, $_SESSION['dateibrowser_allowdirs'])) {
	$_SESSION['dateibrowser_allowdirs'][] = $toadd;
}

session_write_close();

$goto = (isset($_GET['goto'])) ? $_GET['goto'] : '';

if ($goto != '') {
	$rel_path = $goto;
} else {
	$rel_path = absolute_path_to_relative_path($toadd, DATEIBROWSER_ROOT);
}

header('location: '.dir_add_trailing_backslash(DATEIBROWSER_BASE_URL).IDX_FILE.'?dir='.$rel_path);

?>
